//---------------------------------------------------------------------------
#include <exception>
#include <vcl.h>
#include <Math.h>
#pragma hdrstop

#include "MainIntegralUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
// 
unsigned int v=0;
//---------------------------------------------------------------------------
// 
//      'a'  'b',         ,       
//: exception     std,    using  (using std;)    .   
double f1(double x,double a,double b)
{if(b*x)
 return a/(b*x);
 throw std::exception();
}//double f1(double x,double a,double b)
double f2(double x,double a,double b)
{if(x*a+b)
 return a+(1/(x*a+b));
throw std::exception();
}//double f2(double x,double a,double b)
double f(double x,double a,double b)
{static const func_ptr Functions[2]={&f1, &f2}; //   Functions -     (   [2])
 if (v<2)
        return Functions[v](x,a,b);
 //if(v>2) - , .. v   0,     ,  v    [2, 2^32)
 else       Form1->Label7->Caption="Neiasno kakuy function vysyvat!"; //Label7 -   Form1
 return 0; 
}//double f(double x,double a,double b)

double integral(double a, double b, double c, double d, int n, double Eps/*, double (*f)(double)*/)
{// ,     -    -      v
 int i;
 double summa_ab = f(c,a,b) + f(d,a,b);//  f    - a, b.      
 double h = (d - c) / n;
 double summa_nechet = 0, summa_chet;
 double summa_tek = 0, summa_pred ;


 for (i = 2; i < n; i += 2)
        summa_nechet += f(c + i * h,a,b);

 do    {summa_chet = 0;
 	summa_pred = summa_tek;

        for (i = 1; i < n; i += 2)
                summa_chet += f(c + i * h,a,b);

        summa_tek = h / 3 * (summa_ab + 2 * summa_nechet + 4 * summa_chet);


	if (summa_tek == 0)
                summa_tek = Eps;

	summa_nechet += summa_chet;
	n *= 2;
	h /= 2;
       } while (fabs((summa_pred - summa_tek) / summa_tek) > Eps);

 return fabs(summa_tek);
}//double integral(double a, double b, double c, double d, int n, double Eps)
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
 : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExitClick(TObject *Sender)
{Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NewClick(TObject *Sender)
{
 Label7->Caption="";
 A->Clear();
 B->Clear();
 C->Clear();
 D->Clear();
 EPS->Clear();
 N->Clear();
 result1->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SelectorClick(TObject *Sender)
{v = Selector->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IntegrateButtonClick(TObject *Sender)
{
 double a,b,c,d,Eps,n,result;
 //Warnings ,      -   
 Label7->Caption="";

 try
 {

 a=StrToFloat(A->Text);
/*     
 * b=StrToIntDef(B->Text,1);   StrToIntDef   , ,     ,      
 *   ,     ,     ,  double? -    StrToFloat
 * c=StrToIntDef(C->Text,1);
 * d=StrToIntDef(D->Text,1);
 * Eps=StrToIntDef(EPS->Text,1);
 * n=StrToIntDef(N->Text,10);
 *  
 */
 b=StrToFloat(B->Text);
 c=StrToFloat(C->Text);
 d=StrToFloat(D->Text);
 Eps=StrToFloat(EPS->Text);
 n=StrToFloat(N->Text);

 }
 catch(...)
 {
 Label7->Caption="Nevernii format vvedennih chisel!";
 Abort();
 }
/*    ,        
 * if (v==1)
 * result=integral(a=StrToFloat(A->Text), b=StrToIntDef(B->Text), c=StrToIntDef(C->Text),d=StrToIntDef(D->Text),Eps=StrToIntDef(EPS->Text),n=StrToIntDef(N->Text),f1);
 * result1->Text=FloatToStr(result);
 * if (v==2)
 * result=integral(a=StrToFloat(A->Text), b=StrToIntDef(B->Text), c=StrToIntDef(C->Text),d=StrToIntDef(D->Text),Eps=StrToIntDef(EPS->Text),n=StrToIntDef(N->Text),f2);
 *   .        try - catch
 */
  try   {//    ,      ,     ?
         /*  :
          * result=integral(a=StrToFloat(A->Text), b=StrToIntDef(B->Text,1), c=StrToIntDef(C->Text,1),d=StrToIntDef(D->Text,1),Eps=StrToIntDef(EPS->Text,1),n=StrToIntDef(N->Text,1));
          *   :
          */
         result=integral(a, b, c, d,Eps,n);
         result1->Text=FloatToStr(result);
         //  result    ,    ,     
         //    :
         // result1->Text=FloatToStr( integral(a, b, c, d,Eps,n) );
        }//try
  catch (std::exception)//
        {Label7->Caption="divide by zero error!";
        }

}
//---------------------------------------------------------------------------

